/* D-RexGxt - D-RexGxt - GUI Design Tool for GWT
 * Copyright (c) 2008,  KPS Corporation
 * All rights reserved.
 *
 * Open Source License
 * ------------------------------------------------------------------------------------------
 * D-RexGxt is licensed under the terms of the Open Source GPL 3.0 license.
 *
 * http://www.gnu.org/licenses/gpl.html
 *
 * --
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */
package jp.co.kpscorp.gwt.client.design.gxt.delegate.comp;

import jp.co.kpscorp.gwt.client.design.WidgetService;
import jp.co.kpscorp.gwt.client.design.gxt.GxtUtil;

import com.extjs.gxt.ui.client.widget.Component;
import com.extjs.gxt.ui.client.widget.form.Radio;
import com.extjs.gxt.ui.client.widget.form.RadioGroup;


public class RadioGroupDelegate extends MultiFieldDelegate {

	private RadioGroup comp;

	protected String[] props = { "selectionRequired" };

	protected String[] innerProps = { "selectionRequired" };

	public RadioGroupDelegate(WidgetService service, Component widget
) {
		super(service, widget);
		this.comp = (RadioGroup) widget;
	}

	@Override
	public String[] getProps() {
		return GxtUtil.add(super.getProps(), props);
	}

	@Override
	public String[] getInnerProps() {
		return GxtUtil.add(super.getInnerProps(), innerProps);
	}

	@Override
	public Object exec(String mthodName, Object[] parms) {
		if ("getMessages".equals(mthodName)) {
			return comp.getMessages();
		} else if ("getMessages".equals(mthodName)) {
			return comp.getMessages();
		} else if ("isSelectionRequired".equals(mthodName)) {
			return comp.isSelectionRequired();
		} else if ("setSelectionRequired".equals(mthodName)
				&& parms[0] instanceof Boolean) {
			comp.setSelectionRequired((Boolean) parms[0]);
			return comp;
		} else if ("getValue".equals(mthodName)) {
			return comp.getValue();
		} else if ("setValue".equals(mthodName) && parms[0] instanceof Radio) {
			comp.setValue((Radio) parms[0]);
			return comp;
		} else if ("isValid".equals(mthodName)) {
			return comp.isValid();
		}
		return super.exec(mthodName, parms);
	}

	@Override
	public String getIconStyle() {
		return "icon-menu-RG";
	}


}
